unit ufrmplateau;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, Grids, ufrmSnake, Contnrs, uPictures, uDepart,
  Qt, StdCtrls, ufrmApropos, ufrmAide, ufrmGameOver;

type
  Tfrmplateau = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    TimerSnake: TTimer;
    Nouveau1: TMenuItem;
    N1: TMenuItem;
    PaPlateau: TPanel;
    Grille: TDrawGrid;
    PaScore: TPanel;
    PaAfficherScore: TPanel;
    PaAfficherHiScore: TPanel;
    LaAffiche: TLabel;
    LaScore: TLabel;
    Lahiscores: TLabel;
    LaNomHScore1: TLabel;
    LaNomHScore2: TLabel;
    LaNomHScore3: TLabel;
    LaNomHScore4: TLabel;
    LaNomHScore5: TLabel;
    LaHScore1: TLabel;
    LaHScore2: TLabel;
    LaHScore3: TLabel;
    LaHScore4: TLabel;
    LaHScore5: TLabel;
    TimerPause: TTimer;
    LaPause: TLabel;
    N2: TMenuItem;
    APropos1: TMenuItem;
    Aide1: TMenuItem;
    N3: TMenuItem;
    procedure Quitter1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure TimerSnakeTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Nouveau1Click(Sender: TObject);
    procedure TimerPauseTimer(Sender: TObject);
    procedure APropos1Click(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
  private
    ListObj        : TObjectList  ;    // Liste d'Objet contenant un objet representant chaque partie du serpent
    ListScore      : TStringList ;     // StringList contenant les Hi-Scores
    FSnake         : TSnake ;          // Variable pointant sur sur l'objet TSnake
    xtemp          : integer ;         // coordonne temporaire
    ytemp          : integer ;         // coordonne temporaire
    xChange        : integer ;         // coordonne temporaire de changement d'orientation
    yChange        : integer ;         // coordonne temporaire de changement d'orientation
    xdiff          : integer ;         // diffrence de coordonne
    ydiff          : integer ;         // diffrence de coordonne
    xGrenouille    : integer ;         // coordonne de la grenouille
    yGrenouille    : integer ;         // coordonne de la grenouille
    KeyMemory      : word ;            // touche de clavier mmorise
    iScore         : integer ;         // Score
    Ressources     : TResourceStream ; // Ressource contenant les Hi-Scores
    Procedure CalculPosition(xtemp, ytemp: integer);
    Function  PositionCorrect: boolean ;
    Procedure GameOver ;
    Procedure Redessiner(iArgX, iArgY, iArgPos: integer);
    Function  Manger: boolean ;
    Procedure Agrandir ;
    Procedure Accelerer ;
    Procedure PlacerGrenouille ;
//    Procedure AfficherHiScore  ;
//   Procedure RefreshScrore ;
//    Procedure IsHiScore ;
    Procedure AfficherScore;
  public
   Pict : TPicture ;
    { Dclarations publiques }
  end;

var
  frmplateau: Tfrmplateau;

implementation

{$R Score.res }

uses Math;

{$R *.dfm}

procedure Tfrmplateau.Quitter1Click(Sender: TObject);
begin
 close ;
end;

procedure Tfrmplateau.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// Liberer les objets
 if Assigned(FSnake) then
  FSnake.Free ;
 if Assigned(ListScore)then
  ListScore.Free ;
 Ressources.Free ; 
 Action := caFree;
end;

procedure Tfrmplateau.FormCreate(Sender: TObject);
begin
// Charger les diffrentes images dans l'Objet TPictures
 fPictures       := TPictures.Create ;
// Initialiser les variables
 Grille.Visible  := false ;
 LaPause.Visible := false ;
 PaScore.Visible := false ;
 ListScore       := TStringList.Create ;
 // charger les ficher text en .res dans une liste
 Ressources := TResourceStream.Create(hinstance, 'SCORE', 'TEXT');
end;

procedure Tfrmplateau.GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
 i : integer ;
begin
// Affichage de la grenouille  
  if (ACol = xGrenouille) and (ARow = yGrenouille) then
   Grille.Canvas.Draw(Rect.Left, Rect.Top, fPictures.ImageGRENOUILLE.Picture.Graphic);
// Affichage du serpent
 for i:=0 to ListObj.Count-1 do
  begin
  If (Acol = (TSnake(ListObj.items[i])).x) And (ARow = (TSnake(ListObj.items[i])).y) Then
    Grille.Canvas.Draw(Rect.Left, Rect.Top, (TSnake(ListObj.items[i])).Graph);
  end ;
end;

procedure Tfrmplateau.TimerSnakeTimer(Sender: TObject);
begin
if Assigned(ListObj) then
 begin
   Grille.Refresh ;
   CalculPosition(xtemp, ytemp);
   if not PositionCorrect then
    GameOver
   else
   if Manger = true then
    begin
     // on replace la grenouille
     PlacerGrenouille ;
     // agrandissement du serpent
     Agrandir ;
     // accelre la cadence
     Accelerer ;
    end ;
 end ;
end;

Procedure Tfrmplateau.PlacerGrenouille ;
var
 i : integer ;
begin
// On place la grenouille dans la grille
 Randomize ;
 for i := 1 to 19 do
  begin
   xGrenouille := Random(i) ;
   yGrenouille := Random(i) ;
  end ;
end ;

Function Tfrmplateau.Manger ;
begin
 result := false ;
 // Si la position de la tete du serpent = position de la grenouille alors mang !!
 if ((TSnake(ListObj.items[0])).x = xGrenouille) and ((TSnake(ListObj.items[0])).y = yGrenouille) then
  begin
   iScore          := iScore + 10 ;
   result          := true ;
   AfficherScore ;
  end ;
end ;

Procedure Tfrmplateau.AfficherScore;
begin
 LaScore.Caption := IntToStr(iScore);
end;

{Procedure Tfrmplateau.AfficherHiScore  ;
begin
 ListScore.LoadFromStream(Ressources) ;
// affichage des donnes
 RefreshScrore ;
end ;}

{Procedure Tfrmplateau.RefreshScrore ;
var
 i : integer ;
begin
 i                    := length(ListScore.Strings[0])- pos('', ListScore.Strings[0]) ;
 LaNomHScore1.Caption := Copy(ListScore.Strings[0],0,5);
 LaHScore1.Caption    := Copy(ListScore.Strings[0],6,i);

 i                    := length(ListScore.Strings[1])- pos('', ListScore.Strings[1]) ;
 LaNomHScore2.Caption := Copy(ListScore.Strings[1],0,5);
 LaHScore2.Caption    := Copy(ListScore.Strings[1],6,i);

 i                    := length(ListScore.Strings[2])- pos('', ListScore.Strings[2]) ;
 LaNomHScore3.Caption := Copy(ListScore.Strings[2],0,5);
 LaHScore3.Caption    := Copy(ListScore.Strings[2],6,i);

 i                    := length(ListScore.Strings[3])- pos('', ListScore.Strings[3]) ;
 LaNomHScore4.Caption := Copy(ListScore.Strings[3],0,5);
 LaHScore4.Caption    := Copy(ListScore.Strings[3],6,i);

 i                    := length(ListScore.Strings[4])- pos('', ListScore.Strings[4]) ;
 LaNomHScore5.Caption := Copy(ListScore.Strings[4],0,5);
 LaHScore5.Caption    := Copy(ListScore.Strings[4],6,i);
end ; }

Procedure Tfrmplateau.Agrandir ;
var
 i    : integer ;
 x, y : integer ;
begin
 i                        := ListObj.Count ;
 x                        := (TSnake(ListObj.Last)).x ;
 y                        := (TSnake(ListObj.Last)).y ;
 (TSnake(ListObj.Last)).x := (TSnake(ListObj.Last)).x + xdiff ;
 (TSnake(ListObj.Last)).y := (TSnake(ListObj.Last)).y + ydiff ;
 FSnake                   := TSnake.Create(2, 1, x, y) ;
 ListObj.Insert(i-1, FSnake);
end ;

Procedure Tfrmplateau.Accelerer ;
begin
 TimerSnake.Enabled  := false ;
 TimerSnake.Interval := trunc(TimerSnake.Interval * 0.95) ;
 TimerSnake.Enabled  := true ;
end ;

Procedure Tfrmplateau.GameOver ;
var
 FGameOver : TfrmGameOver ;
begin
 TimerSnake.Enabled := false ;
 Grille.Visible     := false ;
 FGameOver          := TfrmGameOver.Create(nil);
 TRY
 FGameOver.ShowModal ;
 FINALLY
  FGameOver.free ;
 END ;
 //IsHiScore ;
end ;

{Procedure Tfrmplateau.IsHiScore ;
var
 i    : integer ;
 j    : integer ;
 n    : integer ;
 sNom : string ;
begin
 sNom := 'XXXXX';
 j := ListScore.Count-1 ;
 for i:= 0 to j do
  begin
   if iScore >= StrToInt(Copy(ListScore.Strings[i],6,length(ListScore.Strings[i])- pos('', ListScore.Strings[i]))) then
    begin
     InputQuery('RECORD !!!', 'Entrez votre nom (5 lettres maxi)', sNom) ;
     sNom := trim(sNom) ;
     if sNom = '' then
      sNom := 'XXXXX';
     ListScore.Insert(i, sNom + ' ' + IntToStr(iScore));
     ListScore.Delete(4) ;  }
  {   ListScore.Delete(4);
     n := j-1 ;
     while n > i do
      begin
       ListObj.Move(n, n+1);
       n := n-1 ;
      end ;  }
    // ListScore.Insert(i, sNom + ' ' + IntToStr(iScore));
   //  ListScore.SaveToStream(Ressources);
 {    exit ;
    end ;
  end ;
end;   }

Function Tfrmplateau.PositionCorrect: boolean ;
var
 xHead : integer ;
 yHead : integer ;
 i     : integer ;
begin
 result := true ;
 xHead  := (TSnake(ListObj.First)).x ;
 yHead  := (TSnake(ListObj.First)).y ;
 // Position du serpent dans la grille
 if (xHead >= 0) and (yHead >= 0) and (xHead <= 20) and (yHead <= 20) then
  begin
  // Verifier qu'il ne se morde pas la queue
   for i:= 1 to ListObj.Count-1 do
    begin
     if (xHead = (TSnake(ListObj.items[i])).x) and (yHead = (TSnake(ListObj.items[i])).y) then
      begin
       result := false ;
       exit ;
      end ;
    end ;
  end
 else
  result := false ;
end ;

Procedure Tfrmplateau.CalculPosition(xtemp, ytemp: integer);
var
 i     : integer ;
begin
 for i:= ListObj.Count-1 downto 0 do
  begin
   xdiff := 0 ;
   ydiff := 0 ;
   if i > 0 then  // Le corp d'abord
    begin
     xdiff                        := (TSnake(ListObj.items[i-1])).x - (TSnake(ListObj.items[i])).x ;
     ydiff                        := (TSnake(ListObj.items[i-1])).y - (TSnake(ListObj.items[i])).y ;
    if (xdiff <> 0) OR (ydiff <> 0) then
     Redessiner(xdiff, ydiff, i);
    (TSnake(ListObj.items[i])).x  := (TSnake(ListObj.items[i-1])).x ;
    (TSnake(ListObj.items[i])).y  := (TSnake(ListObj.items[i-1])).y ;
    end
   else
    begin // la tete ensuite
     (TSnake(ListObj.items[i])).x := (TSnake(ListObj.items[i])).x + xtemp ;
     (TSnake(ListObj.items[i])).y := (TSnake(ListObj.items[i])).y + ytemp ;
     if (xChange <> (TSnake(ListObj.items[i])).x + xtemp) and (yChange <> (TSnake(ListObj.items[i])).y + ytemp) then
      begin
       xChange                    := (TSnake(ListObj.items[i])).x + xtemp ;
       yChange                    := (TSnake(ListObj.items[i])).y + ytemp ;
       Redessiner(xtemp, ytemp, i);
      end ;
    end ;
  end ;
end ;

procedure Tfrmplateau.Nouveau1Click(Sender: TObject);
begin
// lancer le jeu par le decompte
  frmDepart := TfrmDepart.Create(nil);
  frmDepart.ShowModal ;
// Creation des lments
  ListObj   := TObjectList.Create  ;
// Le serpent est cre avec une tete, un corps et la queue  un position donnes
  FSnake    := TSnake.Create(1, 1, 4, 4) ;
  ListObj.Add(FSnake);
  FSnake    := TSnake.Create(2, 1, 3, 4) ;
  ListObj.Add(FSnake) ;
  FSnake    := TSnake.Create(3, 1, 2, 4) ;
  ListObj.Add(FSnake) ;
  xtemp               := 1 ;
  ytemp               := 0 ;
  iScore              := 0 ;
  TimerSnake.Interval := 200 ;
// Afficher le score
  AfficherScore ;
// placement de la grenouille
  PlacerGrenouille ;
// le jeu demarre
  TimerSnake.Enabled := true ;
  Grille.Visible     := true ;
  PaScore.Visible    := true ;
end;

procedure Tfrmplateau.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
// Gestion des touches
if key = VK_UP then
  begin
   if KeyMemory <> VK_down then
    begin
     ytemp     := -1 ;
     xtemp     := 0 ;
     KeyMemory := VK_UP ;
    end ;
  end ;
 if key = VK_down then
  begin
   if KeyMemory <> VK_UP then
    begin
     ytemp     := 1 ;
     xtemp     := 0 ;
     KeyMemory := VK_down ;
    end ;
  end ;
 if key = VK_right then
  begin
   if KeyMemory <> VK_left then
    begin
     xtemp     := 1 ;
     ytemp     := 0 ;
     KeyMemory := VK_right ;
    end ;
  end ;
 if key = VK_left then
  begin
   if KeyMemory <> VK_right then
    begin
     xtemp     := -1 ;
     ytemp     := 0 ;
     KeyMemory := VK_left;
    end ;
  end ;
// pause  
 if key = KEY_P then
  if TimerSnake.Enabled = true then
   begin
    TimerSnake.Enabled := false ;
    TimerPause.Enabled := true ;
   end
  else
   begin
    TimerSnake.Enabled := true ;
    TimerPause.Enabled := false ;
    LaPause.Visible    := false ;  
   end ;
  if key = VK_ESCAPE then
   close ;  
end;

Procedure Tfrmplateau.Redessiner(iArgX, iArgY, iArgPos: integer);
begin
 if iArgX = 0 then //UP ou DOWN
  begin
   if iArgY = 1 then // DOWN
    begin
     case (TSnake(ListObj.items[iArgPos])).iPart of
      1 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageHEADDOWN.Picture.Graphic ;
      2 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBODYDOWN.Picture.Graphic ;
      3 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBACKDOWN.Picture.Graphic ;
     end ;
    end
   else
   if iArgY = -1 then // UP
    begin
     case (TSnake(ListObj.items[iArgPos])).iPart of
      1 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageHEADUP.Picture.Graphic ;
      2 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBODYUP.Picture.Graphic ;
      3 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBACKUP.Picture.Graphic ;
     end ;
    end ;
  end
 else
 if iArgX = 1 then //RIGHT
  begin
   case (TSnake(ListObj.items[iArgPos])).iPart of
    1 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageHEADRIGHT.Picture.Graphic ;
    2 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBODYRIGHT.Picture.Graphic ;
    3 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBACKRIGHT.Picture.Graphic ;
   end ;
  end
 else
 if iArgX = -1 then //LEFT
  begin
   case (TSnake(ListObj.items[iArgPos])).iPart of
    1 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageHEADLEFT.Picture.Graphic ;
    2 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBODYLEFT.Picture.Graphic ;
    3 : (TSnake(ListObj.items[iArgPos])).Graph := fPictures.ImageBACKLEFT.Picture.Graphic ;
   end ;
  end ;
end ;


procedure Tfrmplateau.TimerPauseTimer(Sender: TObject);
begin
 if LaPause.Visible = true then
  LaPause.Visible := false
 else
  LaPause.Visible := true ;
end;

procedure Tfrmplateau.APropos1Click(Sender: TObject);
var
 fPlateau : TfrmAPropos ;
begin
 fPlateau := TfrmAPropos.Create(nil);
 try
  fPlateau.ShowModal ;
 finally
  fPlateau.Free ;
 end ;
end;

procedure Tfrmplateau.Aide1Click(Sender: TObject);
var
 fAide : TfrmAide ;
begin
 fAide := TfrmAide.Create(nil) ;
 TRY
  fAide.ShowModal ;
 FINALLY
  fAide.Free ;
 END ;
end;

end.
